package org.processmining.starstar.cep;

import java.util.List;
import java.util.UUID;
import java.util.concurrent.ConcurrentHashMap;

public class EsperConditions {
	public ConcurrentHashMap<String, String> activityCEPeventTypeCorrespondence;
	public ConcurrentHashMap<String, String> classCEPeventTypeCorrespondence;
	
	public ConcurrentHashMap<UUID, Object> timeBatchConditionsValue;
	public ConcurrentHashMap<String, List<UUID>> timeBatchActivityConditions;
	public ConcurrentHashMap<UUID, List<String>> invTimeBatchActivityConditions;
	public ConcurrentHashMap<String, List<UUID>> timeBatchClassConditions;
	public ConcurrentHashMap<UUID, List<String>> invTimeBatchClassConditions;
	
	public ConcurrentHashMap<String, String> activityActivationQuery;
	public ConcurrentHashMap<String, String> classActivationQuery;
	public ConcurrentHashMap<String, String> activityActivationCondition;
	public ConcurrentHashMap<String, String> classActivationCondition;
	
	public EsperConditions() {
		activityCEPeventTypeCorrespondence = new ConcurrentHashMap<String, String>();
		classCEPeventTypeCorrespondence = new ConcurrentHashMap<String, String>();
		
		timeBatchConditionsValue = new ConcurrentHashMap<UUID, Object>();
		timeBatchActivityConditions = new ConcurrentHashMap<String, List<UUID>>();
		invTimeBatchActivityConditions = new ConcurrentHashMap<UUID, List<String>>();
		timeBatchClassConditions = new ConcurrentHashMap<String, List<UUID>>();
		invTimeBatchClassConditions = new ConcurrentHashMap<UUID, List<String>>();
		
		activityActivationQuery = new ConcurrentHashMap<String, String>();
		classActivationQuery = new ConcurrentHashMap<String, String>();
		activityActivationCondition = new ConcurrentHashMap<String, String>();
		classActivationCondition = new ConcurrentHashMap<String, String>();
	}
	
	public EsperConditions clone() {
		EsperConditions ret = new EsperConditions();
		
		ret.activityCEPeventTypeCorrespondence = new ConcurrentHashMap<String, String>(this.activityCEPeventTypeCorrespondence);
		ret.classCEPeventTypeCorrespondence = new ConcurrentHashMap<String, String>(this.classCEPeventTypeCorrespondence);
		
		ret.timeBatchConditionsValue = new ConcurrentHashMap<UUID, Object>(this.timeBatchConditionsValue);
		ret.timeBatchActivityConditions = new ConcurrentHashMap<String, List<UUID>>(this.timeBatchActivityConditions);
		ret.invTimeBatchActivityConditions = new ConcurrentHashMap<UUID, List<String>>(this.invTimeBatchActivityConditions);
		ret.timeBatchClassConditions = new ConcurrentHashMap<String, List<UUID>>(this.timeBatchClassConditions);
		ret.invTimeBatchClassConditions = new ConcurrentHashMap<UUID, List<String>>(this.invTimeBatchClassConditions);
		
		ret.activityActivationQuery = new ConcurrentHashMap<String, String>(this.activityActivationQuery);
		ret.classActivationQuery = new ConcurrentHashMap<String, String>(this.classActivationQuery);
		ret.activityActivationCondition = new ConcurrentHashMap<String, String>(this.activityActivationCondition);
		ret.classActivationCondition = new ConcurrentHashMap<String, String>(this.classActivationCondition);
		
		return ret;
	}
}
