package org.processmining.starstar.cep;

import java.util.Date;
import java.util.Map;
import java.util.Random;

import com.espertech.esper.client.Configuration;
import com.espertech.esper.client.EPAdministrator;
import com.espertech.esper.client.EPRuntime;
import com.espertech.esper.client.EPServiceProvider;
import com.espertech.esper.client.EPServiceProviderManager;
import com.espertech.esper.client.EPStatement;
import com.espertech.esper.client.EventBean;
import com.espertech.esper.client.UpdateListener;

public class EsperTrial {
	static Random generator = new Random();
	
	static void GenerateRandomTick(EPRuntime cepRT) {

	    double price = (double) generator.nextInt(10);
	    long timeStamp = System.currentTimeMillis();
	    String symbol = "AAPL";
	    Tick tick = new Tick(symbol, price, timeStamp);
	    System.out.println("Sending tick:" + tick);
	    cepRT.sendEvent(tick);

	}
	
	public static void main(String[] args) {
		Configuration cepConfig = new Configuration();
		cepConfig.addEventType("StockTick", Tick.class.getName());
		EPServiceProvider cep = EPServiceProviderManager.getProvider("myCEPEngine", cepConfig);
		EPRuntime cepRT = cep.getEPRuntime();
		
		EPAdministrator cepAdm = cep.getEPAdministrator();
        //EPStatement cepStatement = cepAdm.createEPL("select avg(price) from StockTick(symbol='AAPL').win:length(2) having avg(price) > 6.0");
		EPStatement cepStatement = cepAdm.createEPL("select symbol, price, timeStamp, constantt from StockTick(symbol='AAPL').win:length(2)");
        
        cepStatement.addListener(new CEPListener());
        
        for (int i = 0; i < 5; i++) {
            GenerateRandomTick(cepRT);
        }
	}
}

class Tick {
    String symbol;
    Double price;
    Date timeStamp;
    String constantt;

    public Tick(String s, double p, long t) {
        symbol = s;
        price = p;
        timeStamp = new Date(t);
        constantt = "ciao";
    }
    public double getPrice() {return price;}
    public String getSymbol() {return symbol;}
    public Date getTimeStamp() {return timeStamp;}
    public String getConstantt() {return constantt;}

    @Override
    public String toString() {
        return "Price: " + price.toString() + " time: " + timeStamp.toString();
    }
}

class CEPListener implements UpdateListener {
    public void update(EventBean[] newData, EventBean[] oldData) {
    	System.out.println(oldData);
    	System.out.println(newData.length);
    	try {
	    	Map<String, Object> aaa = (Map<String,Object>)(newData[0].getUnderlying());
	        System.out.println("Event received: " + aaa.get("constantt"));
    	}
    	catch (Exception ex2) {
    		ex2.printStackTrace();
    	}
    }
}