package org.processmining.starstar.elements;

import java.util.ArrayList;
import java.util.List;

public class XOCObjectClass {
	String classLabel;
	List<XOCObject> subscribedObjects;
	
	public XOCObjectClass(String classLabel) {
		this.classLabel = classLabel;
		this.subscribedObjects = new ArrayList<XOCObject>();
	}
	
	public void subscribeObject(XOCObject object) {
		this.subscribedObjects.add(object);
	}
	
	public String getClassLabel() {
		return this.classLabel;
	}
	
	public List<XOCObject> getSubscribedObjects() {
		return this.subscribedObjects;
	}
	
	public String getResume() {
		StringBuilder ret = new StringBuilder();
		ret.append("XOCObjectClass classLabel ="+classLabel+" subscribedObjects =\n");
		
		for (XOCObject object : subscribedObjects) {
			ret.append(object.getShortResume());
		}
		return ret.toString();
	}
	
	public void printResume() {
		System.out.println(getResume());
	}
}
