package org.processmining.starstar.elements;

import java.util.HashMap;
import java.util.Map;

public class XOCObjectVersion {
	String objectName;
	Map<String, String> attributes;
	boolean isTimed;
	XOCObject correspondingObject;
	XOCObjectClass objectClass;
	
	// memorize the address to this map
	Map<String, XOCObjectClass> xocObjectClasses;
	
	public XOCObjectVersion(String objectName, Map<String, XOCObjectClass> xocObjectClasses) {
		this.objectName = objectName;
		this.attributes = new HashMap<String, String>();
		this.isTimed = false;
		this.xocObjectClasses = xocObjectClasses;
	}
	
	public String getLabel() {
		return this.objectName;
	}
	
	public Map<String, String> getAttributes() {
		return this.attributes;
	}
	
	public void addAttribute(String attributeName, String attributeValue) {		
		if (attributeName.toLowerCase().contains("date")  || attributeName.toLowerCase().contains("time")) {
			this.isTimed = true;
		}
		if (attributeName.toLowerCase().equals("class")) {
			if (!xocObjectClasses.containsKey(attributeValue)) {
				xocObjectClasses.put(attributeValue, new XOCObjectClass(attributeValue));
			}
			this.objectClass = xocObjectClasses.get(attributeValue);
		}
		this.attributes.put(attributeName, attributeValue);
	}
	
	public XOCObject getCorrespondingObject() {
		return this.correspondingObject;
	}
	
	public void setCorrespondingObject(XOCObject object) {
		this.correspondingObject = object;
	}
	
	public XOCObjectClass getObjectClass() {
		return this.objectClass;
	}
	
	public boolean getIsTimed() {
		return this.isTimed;
	}
	
	public String getResume() {
		StringBuilder ret = new StringBuilder();
		ret.append("objectName: "+objectName);
		if (this.objectClass != null) {
			ret.append(" objectClass: "+this.objectClass.getClassLabel());
		}
		ret.append(" attributes: "+attributes);
		ret.append("\n");
		return ret.toString();
	}
	
	public void printResume() {
		System.out.println(getResume());
	}
}
