package org.processmining.starstar.model;

import java.util.List;
import java.util.Map;

import org.processmining.starstar.elements.XOCActivity;
import org.processmining.starstar.elements.XOCObject;
import org.processmining.starstar.elements.XOCObjectClass;
import org.processmining.starstar.plugins.StarStarModelNeo4JImporter;

public class StarStarModelNeo4J extends StarStarModel {
	StarStarModelNeo4JImporter importer;
	
	public StarStarModelNeo4J(StarStarModelNeo4JImporter importer) {
		this.importer = importer;
	}
	
	@Override
	public List<XOCActivity> getActivities() {
		return this.importer.getActivities();
	}
	
	@Override
	public Map<String, XOCObjectClass> getXocObjectClasses() {
		return this.importer.getXocObjectClasses();
	}
	
	@Override
	public Map<XOCObject, List<XOCObject>> getIntersectedObjects() {
		importer.getAllObjectsFromNeo4J();
		importer.getAllEventsFromNeo4J();
		importer.calculateObjectIntersection();
		return importer.returnIntersectedObjects();
	}
}
