package org.processmining.starstar.model;

import java.util.List;
import java.util.Map;
import java.util.Set;

import org.processmining.starstar.cep.EsperConditions;
import org.processmining.starstar.elements.XOCActivity;
import org.processmining.starstar.elements.XOCEvent;
import org.processmining.starstar.elements.XOCObject;
import org.processmining.starstar.elements.XOCObjectClass;
import org.processmining.starstar.parser.ParsedXOC;

public class StarStarModelXOC extends StarStarModel {
	ParsedXOC parsedXoc;
	
	public StarStarModelXOC(ParsedXOC parsedXoc) {
		super();
		
		this.parsedXoc = parsedXoc;
	}
	
	@Override
	public List<XOCActivity> getActivities() {
		return this.parsedXoc.getActivities();
	}
	
	@Override
	public Map<XOCObject, List<XOCObject>> getIntersectedObjects() {
		System.out.println("calculating object intersection");
		//this.parsedXoc.calculateObjectIntersection();
		System.out.println("calculated object intersection");
		
		return this.parsedXoc.getIntersectedObjects();
	}
	
	@Override
	public Map<String, XOCObjectClass> getXocObjectClasses() {
		return this.parsedXoc.getXocObjectClasses();
	}
	
	@Override
	public void restoreUnfiltered() {
		this.parsedXoc.restoreUnfiltered();
	}
	
	@Override
	public void filterXocOnActivity(String activity, String wantedObjectClass) {
		this.parsedXoc.filterXocOnActivity(activity, wantedObjectClass);
	}
	
	@Override
	public void filterXocOnEdges(Set<ModelEdge> edges, String operation) {
		this.parsedXoc.filterXocOnEdges(edges, operation);
	}
	
	@Override
	public void filterXocOnSubgraph(Subgraph subgraph) {
		this.parsedXoc.filterXocOnSubgraph(subgraph);
	}
	
	@Override
	public void setCheckpointModel() {
		this.parsedXoc.cloneIntoUnfiltered(true);
	}
	
	@Override
	public void filterXocOnSpecifiedSetOfActivity(List<String> activities) {
		this.parsedXoc.setWantedActivities(activities);
	}
	
	@Override
	public List<Subgraph> discoverMostInterestingSubgraph(String activity) {
		return this.parsedXoc.discoverMostInterestingSubgraph(activity);
	}
	
	@Override
	public List<XOCEvent> getEventsList() {
		return this.parsedXoc.orderedXocEvents;
	}
	
	@Override
	public EsperConditions getEsperConditions() {
		return this.parsedXoc.esperConditions;
	}
}
