package org.processmining.starstar.plugins;

import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.starstar.model.StarStarModel;
import org.processmining.starstar.model.StarStarModelNeo4J;

@Plugin(name = "StarStarModel Neo4J Connector",
returnLabels = { "StarStarModel" },
returnTypes = { StarStarModel.class },
parameterLabels = { "" },
help = "StarStarModel Neo4J Connector",
userAccessible = true)
public class StarStarModelNeo4JImporterProM {
	@PluginVariant(requiredParameterLabels = { })
	@UITopiaVariant(affiliation = "PADS RWTH", author = "Alessandro Berti", email = "a.berti@pads.rwth-aachen.de")
	public StarStarModel importer(PluginContext context) {
		StarStarModelNeo4JImporter importer = new StarStarModelNeo4JImporter("bolt://localhost:7687", "neo4j", "aaaaa");
		importer.getActivitiesFromNeo4J();
		StarStarModelNeo4J model = new StarStarModelNeo4J(importer);
		return model;
	}
}
